import nbap.*;
import nbap.test_nbap.*;

/* Universal classes from the OSS runtime library */
import com.oss.asn1.*;
import com.oss.util.*;

/* Java I/O classes */
import java.io.*;

public class AutoDecoding {
    public static void main(String args[]) {
	// Initialize the project
	try {
	    Nbap.initialize();
	} catch (Exception e) {
    	    System.out.println("Initialization exception: " + e);
            System.exit(1);
	}

	Coder coder = Nbap.getPERAlignedCoder();

	// Set the decoder to emit trace output
	coder.enableDecoderDebugging();
	// Set the decoder to decode open types automatically
	coder.enableAutomaticDecoding();

	//------------------------ AUTOMATIC decoding --------------------

	try {
	    // Create the input for the decoder. The decoder will read the
	    // encoded message from the disk file
	    FileInputStream source = new FileInputStream("cellsetuptdd.per");
	    
	    System.out.println();
            System.out.println("The decoder's trace messages ...");
            System.out.println();

            // Decode pdu in ONE step
            NBAP_PDU message = (NBAP_PDU)coder.decode(source, new NBAP_PDU());

	    // Print the value decoded
	    System.out.println();
	    System.out.println("The NBAP message decoded:");
	    System.out.println(message);
	} catch (Exception e) {
	    System.out.println("Unexpected exception: " + e);
	}
    }
}

