@echo off
setlocal
set CLASSPATH=%CD%;%CLASSPATH%
set JAVAC=javac

if %1. == . goto continue
if %1. == cleanup. goto cleanup
echo Invalid argument "%1". Pass either nothing or 'clean'.
echo Usage: run [no arguments^|clean]
exit /b 1

:continue
echo ASN.1-compiling the syntax...
echo.
asn1pjav nbap -err nbap.log -per
if errorlevel 1 (
    echo Error ASN.1-compiling.
    exit /b 1
) 

if exist "%OSS_ASN1_JAVA%\lib\oss.jar" goto next
echo The environment variable OSS_ASN1_JAVA not set.  Exiting...
exit /b 1

:next
cd nbap
echo Java-compiling generated classes...
echo.
call nbap.bat %JAVAC% -g >>..\nbap.log
cd ..
if not exist cellsetuptdd.per (
	echo cellsetuptdd.per not found.
    exit /b 1
)

%JAVAC% -g *.java >>nbap.log
if not exist AutoDecoding.class (
    echo Error Java-compiling.
	echo AutoDecoding.class not found.
    exit /b 1
)

if not exist ManualDecoding.class (
    echo Error Java-compiling.
	echo ManualDecoding.class not found.
    exit /b 1
)

echo Running the test (automatic decoding of the NBAP message)...
echo.
java AutoDecoding
echo Running the test (manual decoding of the NBAP message)...
echo.
java ManualDecoding

if exist nbap (
	rmdir /s /q nbap
    exit /b 0
)

:cleanup
if exist nbap     rmdir /s /q nbap
if exist nbap.log del nbap.log
if exist *.class  del *.class
